## / / / / / / / / / / / / / /
## PROJECT CONFIGURATION
##

PROJCONF.VALUES = list(
    artifact.filter.base = TRUE,
    synchronicity = FALSE,
    synchronicity.time.window = 5
)


## / / / / / / / / / / / / / /
## NETWORK CONFIGURATION
##

## create network configuration for the whole analysis
NETCONF = NetworkConf$new()

## set the appropriate values
NETCONF$update.values(list(
    author.relation = AUTHOR.RELATION,
    author.directed = FALSE,
    author.only.committers = FALSE,
    author.all.authors = TRUE,

    artifact.relation = ARTIFACT.RELATION,
    artifact.directed = FALSE,

    edge.attributes = c("date", "hash", "message.id", "thread", "file", "artifact.type"),
    simplify = TRUE,
    skip.threshold = 1000000
))


## / / / / / / / / / / / / / /
## GLOBAL LISTS
##

CASESTUDIES = c("apache-http", "busybox", "ffmpeg", "git",
                "llvm", "openssl", "postgres", "qemu", "uboot", "wine")
## no feature data: "django", "jailhouse",
## broken somehow: "gcc",
CASESTUDIES.REAL = c("apache-http" = "Apache HTTP", "busybox" = "BusyBox", "django" = "Django",
                     "ffmpeg" = "FFmpeg", "gcc" = "GNU Compiler Collection", "git" = "Git",
                     "jailhouse" = "Jailhouse", "llvm" = "LLVM", "openssl" = "OpenSSL",
                     "postgres" = "PostgreSQL", "qemu" = "QEMU", "uboot" = "U-Boot",
                     "wine" = "Wine")
ARTIFACTS = c("file", "function", "feature")
ARTIFACTS.UPPER = tools::toTitleCase(ARTIFACTS)
ARTIFACT.RELATIONS = c("cochange") # , "callgraph"
MOTIFS = c("triangle", "square")
MOTIFS.UPPER = tools::toTitleCase(MOTIFS)


## / / / / / / / / / / / / / /
## NULL-MODEL ITERATIONS
##
NULL.ITERATIONS = 25
