# !/bin/bash

DIR=$(basename ${PWD})
SRC="codeface@codeface:/scratch/codeface/${DIR}"
DEST="${PWD}"

DATA="data-v3"
LOGS="logs-v3"

SYNC="${LOGS}" # ${DATA}
#CS="apache-http busybox git llvm openssl postgres" # ffmpeg qemu uboot wine
CS="busybox git llvm openssl"
#CS="llvm openssl"
# no feature data: django jailhouse
ARTS="file function feature"
# broken somehow: gcc
TW="3_months" # 3_months 6_months 9_months 12_months releases


## sync data
echo ":: SYNCING ${DATA}"
echo

for tw in ${TW}; do

    ## sync case studies
    for cs in ${CS}; do

        # ## complete
        # rsync -aiS0 --delete --exclude="null*/" "${SRC}/${DATA}/${tw}/${cs}/" "${DEST}/${DATA}/${tw}/${cs}"

        ## parts
        for art in ${ARTS}; do
            ART_PATH="${DATA}/${tw}/${cs}/${cs}_${art}_cochange/sensitivity"
            ART_SRC="${SRC}/${ART_PATH}/"
            ART_DEST="${DEST}/${ART_PATH}"

            mkdir -p "${ART_DEST}"

            rsync -aiS0 "${ART_SRC}" "${ART_DEST}"
        done

    done

    ## sync results
    rsync -aiS0 "${SRC}/${DATA}/${tw}/results/" "${DEST}/${DATA}/${tw}/results"
    # --delete

done

echo
echo


## sync logs
echo ":: SYNCING ${LOGS}"
echo

rsync -aiS0 --delete "${SRC}/${LOGS}/" "${DEST}/${LOGS}"

echo
echo


## check logs
for tw in ${TW}; do

    for cs in ${CS}; do
        echo ":: CHECKING LOGS ${cs} ${tw}"
        mkdir -p ${LOGS}/${tw}/$cs/

        # CRIT="Script done"
        CRIT="CR analysis done"

        FILTER="_" # catches all logs
        FILTER="sensitivity" # sensitivity logs only

        complete=$(grep -l -r "$CRIT" ${LOGS}/${tw}/$cs/ | grep "$FILTER" | sort -V)
        countComplete=$(echo "$complete" | sed -e '/^$/d' | wc -l)
        broken=$(grep -L -r "$CRIT" ${LOGS}/${tw}/$cs/ | grep "$FILTER" | sort -V)
        countBroken=$(echo "$broken" | sed -e '/^$/d' | wc -l)
        echo "$countComplete completed"
        # echo "$complete"
        echo "$countBroken broken"
        echo "$broken"
        echo
    done

done
